--levels

local _lg = love.graphics

Level = class('Level')

function Level:initialize(w,h)
	self.w = w
	self.h = h
	self.grid = {}
	self.lights = {}
end

function Level:draw()
	lighting_engine.update_canvas(canvas_lights, self)
	self:update_canvas(canvas_sprites)
	_lg.setCanvas(canvas_sprites)
	_lg.setCanvas()
	_lg.draw(canvas_lights)
	_lg.setBlendMode('multiplicative')
	_lg.draw(canvas_sprites)
	_lg.setBlendMode('alpha')
end

function Level:update(dt)
	lighting_engine.update(dt,self)
end

function Level:update_canvas(canvas)
	_lg.setCanvas(canvas)
	_lg.setBlendMode('alpha')
    local offset_x = mapX % tileSize
    local offset_y = mapY % tileSize
    local firstTile_x = math.floor(mapX / tileSize)
    local firstTile_y = math.floor(mapY / tileSize)
    
    for y=0, (map_display_h + map_display_buffer) do
        for x=0, (map_display_w + map_display_buffer) do
            if y+firstTile_y >= 0 and y+firstTile_y <= self.h
                and x+firstTile_x >= 0 and x+firstTile_x <= self.w
            then
                _lg.draw(
                    self.grid[y+firstTile_y-map_display_buffer][x+firstTile_x-map_display_buffer].sprite, 
                    (x*tileSize) - offset_x - map_display_buffer*tileSize, 
                    (y*tileSize) - offset_y - map_display_buffer*tileSize)
            end
        end
    end
    _lg.setCanvas()
end









