--Lighting Example
--Kenneth D'Amica 2012

--Top-down engine

require('libs.middleclass')
require('level')

local _lg = love.graphics
local _mouse = love.mouse

pi = math.pi
lighting_engine = require('lighting')
canvas_lights = _lg.newCanvas()
canvas_sprites = _lg.newCanvas()

function love.load()

	local map_w = 40 
	local map_h = 40

	mouse = {}
	map_display_buffer = 2 
	_lg.setBackgroundColor(0,0,0)
	scrHeight = _lg.getHeight()
	scrWidth = _lg.getWidth()
	tileSize = 32
	angle_controller = {angle = pi/4}
	
	current_level = Level:new(map_w,map_h)
	tiles = {
		[1] = _lg.newImage("grass1.png"),
		[0] = _lg.newImage("rock.png"),
	}
	current_level.grid = GenerateRandomMap(tiles, map_w,map_h)
	
	lighting_engine.new_light(current_level, 500,500, nil, 250,1.3*pi, .45*pi,nil,50)
	
	lighting_engine.new_light(current_level, 200,200,nil, 200,pi/4, pi/3.2,nil,nil,nil,nil, 'spinning')
	
	lighting_engine.new_light(current_level, 500,100, nil, 200,3*pi/4, pi/6, nil, 125, {r=255,g=100,b=0}, nil, 'spinning')
	lighting_engine.new_light(current_level, 500,100, nil, 200,-1*pi/4, pi/6, nil, 125, {r=255,g=100,b=0}, nil, 'spinning')

	map_display_w = 26
    map_display_h = 20 
	mapX = 0
	mapY = 0
end

function love.update(dt)
	current_level:update(dt)	
end

function love.draw()
	current_level:draw()
	_lg.print('Press r to generate new map.',0,0)
end

function love.keypressed(key,code)
	if key == 'r' then
		current_level.grid = GenerateRandomMap(tiles, 40,40)
	end	
end

function love.mousepressed(x,y,button)

end

function GenerateRandomMap(tile, w,h)

	local map = {}
	for i = -5,math.ceil(h) +5 do
		map[i] = {}
		for j = -5,math.ceil(w)+5 do
			map[i][j] = {}
			if math.random(20) == 1 or i == 0 or j == 0 or i == 18 or j == 24 then --or (j > 10 and i ~= 5) then
				map[i][j].sprite = tile[0]
				map[i][j].solid = true
			else
				map[i][j].sprite = tile[1]
				map[i][j].solid = false
			end 
		end
	end

	return map	
end


